#include "../../Includes/ClientCore.cpp"

#define CONFIG_FILE ".\\plugin\\hotkeys.ini"

bool settingDropToCubeHotkey = 0;
bool settingTransmuteHotkey = 0;
bool settingStashHotkey = 0;
bool settingDropItemHotkey = 0;
int dropToCubeHotkey = 0;
int transmuteHotkey = 0;
int stashHotkey = 0;
int dropItemHotkey = 0;

BOOL PRIVATE SetDropToCubeHotkey(char** argv, int argc);
BOOL PRIVATE SetTransmuteHotkey(char** argv, int argc);
BOOL PRIVATE SetStashHotkey(char** argv, int argc);
BOOL PRIVATE SetDropItemHotkey(char** argv, int argc);
void ReadConfig();
void WriteConfig();

CLIENTINFO
(
	0,3,
	"deathrat",
	"modified version by deathrat",
	"Hotkey",
	""
)

void ReadConfig()
{
	dropToCubeHotkey = GetPrivateProfileInt("Hotkeys", "DropToCube", 0, CONFIG_FILE);
	transmuteHotkey = GetPrivateProfileInt("Hotkeys", "Transmute", 0, CONFIG_FILE);
	stashHotkey = GetPrivateProfileInt("Hotkeys", "Stash", 0, CONFIG_FILE);
	dropItemHotkey = GetPrivateProfileInt("Hotkeys", "DropItem", 0, CONFIG_FILE);
}

void WriteConfig()
{
	char configBuff[64];

	sprintf_s(configBuff, sizeof(configBuff)/sizeof(configBuff[0]), "%d", dropToCubeHotkey);
	WritePrivateProfileString("Hotkeys", "DropToCube", configBuff, CONFIG_FILE);

	sprintf_s(configBuff, sizeof(configBuff)/sizeof(configBuff[0]), "%d", transmuteHotkey);
	WritePrivateProfileString("Hotkeys", "Transmute", configBuff, CONFIG_FILE);

	sprintf_s(configBuff, sizeof(configBuff)/sizeof(configBuff[0]), "%d", stashHotkey);
	WritePrivateProfileString("Hotkeys", "Stash", configBuff, CONFIG_FILE);

	sprintf_s(configBuff, sizeof(configBuff)/sizeof(configBuff[0]), "%d", dropItemHotkey);
	WritePrivateProfileString("Hotkeys", "DropItem", configBuff, CONFIG_FILE);
}

BOOL PRIVATE SetDropToCubeHotkey(char** argv, int argc)
{
	settingDropToCubeHotkey = true;

	server->GameStringf("c5Transmutec0: Next key pressed will be the drop to cube hotkey...");

	return TRUE;
}

BOOL PRIVATE SetTransmuteHotkey(char** argv, int argc)
{
	settingTransmuteHotkey = true;

	server->GameStringf("c5Transmutec0: Next key pressed will be the transmute hotkey...");

	return TRUE;
}

BOOL PRIVATE SetStashHotkey(char** argv, int argc)
{
	settingStashHotkey = true;

	server->GameStringf("c5Stashc0: Next key pressed will be the stash hotkey...");

	return TRUE;
}

BOOL PRIVATE SetDropItemHotkey(char** argv, int argc)
{
	settingDropItemHotkey = true;

	server->GameStringf("c5DropItemc0: Next key pressed will be the drop item hotkey...");

	return TRUE;
}

VOID EXPORT OnGameJoin(THISGAMESTRUCT* thisgame)
{
	ReadConfig();
}

BYTE EXPORT OnGameKeyDown(BYTE iKeyCode)
{
	if(settingDropToCubeHotkey || settingTransmuteHotkey || settingStashHotkey || settingDropItemHotkey)
	{
		
		int hotkey = 0;

		if(iKeyCode == 0 || iKeyCode == VK_ESCAPE || iKeyCode == VK_RETURN)
		{
			server->GameStringf("c:Hotkeyc0: Unbound hotkey");
			hotkey = 0;
		}
		else
		{
			hotkey = iKeyCode;
			server->GameStringf("c:Hotkeyc0: Hotkey set to %d", iKeyCode);
		}

		if(settingDropToCubeHotkey)
		{
			dropToCubeHotkey = hotkey;
		}
		if(settingTransmuteHotkey)
		{
			transmuteHotkey = hotkey;
		}
		if(settingStashHotkey)
		{
			stashHotkey = hotkey;
		}
		if(settingDropItemHotkey)
		{
			dropItemHotkey = hotkey;
		}

		settingDropToCubeHotkey = false;
		settingTransmuteHotkey = false;
		settingStashHotkey = false;
		settingDropItemHotkey = false;

		WriteConfig();
	}
	else
	{
		if(iKeyCode == transmuteHotkey)
		{
			me->DropCursorItemToStorage(STORAGE_CUBE);
		}
		if(iKeyCode == dropToCubeHotkey)
		{
			if(me->GetCursorItem() == 0)
			{
				me->Transmute();
			}
			else
			{
				server->GameStringf("c0Warning: You must not have an item selected by the cursor in order to transmute.");
			}
		}
		if(iKeyCode == stashHotkey)
		{
			if(me->IsInTown())
			{
				me->DropCursorItemToStorage(STORAGE_STASH);
			}
			else
			{
				server->GameStringf("c0Warning: You have to be in town or accessing your stash in order to deposit an item.");
			}
		}
		if(iKeyCode == dropItemHotkey)
		{
			if(me->GetCursorItem != 0)
			{
				me->DropCursorItemToGround();
			}
		}
	}

	return iKeyCode;
}



MODULECOMMANDSTRUCT ModuleCommands[]=
{
	{
		"help",
		OnGameCommandHelp,
		"helpc0 List commands available in this module.\n"
		"<command> helpc0 Shows detailed help for <command> in this module."
	},
	{
		"SetDropToCube",
		SetDropToCubeHotkey,
		"Sets the hotkey to drop item to cube"
	},
	{
		"SetTransmute",
		SetTransmuteHotkey,
		"Sets the hotkey to transmute"
	},
	{
		"SetStash",
		SetStashHotkey,
		"Sets the hotkey to stash"
	},
	{
		"SetDropItem",
		SetDropItemHotkey,
		"Sets the hotkey to drop items on the ground"
	},
	{NULL}
};